/*
 * @Descripttion: 
 * @version: 
 * @Author: penghui
 * @Date: 2023-07-12 11:24:05
 * @LastEditors: penghui
 * @LastEditTime: 2023-07-13 19:11:15
 */

import { _decorator, Camera, Sprite, RenderTexture, director, Director, Texture2D, game, view, v2, Component } from "cc";
import TexturePlus from "../TexturePlus";
import Light from "./Light";
import LightUtils from "./LightUtils";
import Obstacle from "./Obstacle";


const {ccclass, property} = _decorator;

@ccclass
export default class UILight extends Component {
    
    @property(Obstacle)
    private obstacle: Obstacle = null;
    @property(Light)
    private light: Light = null;
    @property(Sprite)
    private spr: Sprite = null;
    onLoad () {
        
    }

    start () {
        let viewSize = view.getVisibleSize();
        this.obstacle.addPolygon('', [
            v2(0, 0), v2(viewSize.width, 0), v2(viewSize.width, viewSize.height), v2(0, viewSize.height)
        ]);

        let ndObstacle = this.obstacle.node;
        for(let i=0; i<ndObstacle.children.length; i++) {
            let node = ndObstacle.children[i];
            let com = node.getComponent(TexturePlus);
            if(!com) continue;
            
            let points = com.polygon.concat([]);
            let b = v2(node.getPosition().x,node.getPosition().y);
            points = points.map(e => e.add(b));

            this.obstacle.addPolygon(com.node.uuid, points);
        }
    }


    private draw() {
        let polygons = this.obstacle.getPolygons(this.light.getBound());
        
        let a = v2(this.light.node.getPosition().x,this.light.node.getPosition().y);
        let intersections = LightUtils.getIntersections(a, polygons);
        this.light.draw(intersections);
    }

    update (dt: number) {
        // this.camera.render();

        this.draw();       
    }
}
