import { Enum, Mat4, Texture2D, UITransform, Vec2, _decorator, macro, v2,Node, EventTouch, UIRenderer } from "cc";


enum TextureType {
    Cut,            // 裁剪
    Stretch         // 拉伸, 暂未实现
}

let _vec2_temp = new Vec2();
let _mat4_temp = new Mat4();

const {ccclass, menu, executeInEditMode, property} = _decorator;

@ccclass
@executeInEditMode
@menu('i18n:MAIN_MENU.component.ui/TexturePlus')
export default class TexturePlus extends UIRenderer {
    static Type = TextureType;
    
    @property(Texture2D)
    _texture: Texture2D = null;
    @property(Texture2D)
    get texture() {
        return this._texture;
    }
    set texture(val: Texture2D) {
        this._texture = val;
        let l = -val.width/2, b = -val.height/2, t = val.height/2, r = val.width/2;
        this.polygon = [v2(l, b), v2(r, b), v2(r, t), v2(l, t)];
        this.node.getComponent(UITransform).width = val.width; this.node.getComponent(UITransform).height = val.height;
        // this._updateMaterial();
    }

    // _type: TextureType = 0;
    // @property({type: Enum(TextureType), serializable: true})
    // get type() {
    //     return this._type;
    // }
    // set type(val: TextureType) {
    //     this._type = val;
    //     this.setVertsDirty();
    // }

    @property({type: [Vec2], serializable: true})
    _polygon: Vec2[] = [];
    @property({type: [Vec2], serializable: true})
    public get polygon() {
        return this._polygon;
    }
    public set polygon(points: Vec2[]) {
        this._polygon = points;
        // this._updateVerts();
    }

    // @property({type: Enum(macro.BlendFactor), override: true})
    // srcBlendFactor: macro.BlendFactor = macro.BlendFactor.SRC_ALPHA;

    // @property({type: Enum(macro.BlendFactor), override: true})
    // dstBlendFactor: macro.BlendFactor = macro.BlendFactor.ONE_MINUS_SRC_ALPHA;

    // @property(Boolean)
    // editing: boolean = false;
    
    // _assembler: Assembler = null;

    // onLoad() {
    //     this.node['_hitTest'] = this._hitTest.bind(this);
    // }

    // start() {
    //     this.node.on(Node.EventType.TOUCH_START, () => {
    //         console.log("click texture plus");
    //     }, this);
    //     this.node.on(Node.EventType.TOUCH_MOVE, (e: EventTouch) => {
    //         this.node.x += e.getDeltaX();
    //         this.node.y += e.getDeltaY();
    //     }, this);
    // }

    // private _updateVerts() {
    //     this.setVertsDirty();
    // }
    // setVertsDirty() {
    //     throw new Error("Method not implemented.");
    // }

    // public _updateMaterial() {
    //     let texture = this._texture;
    //     let material = this.getMaterial(0);
    //     if(material) {
    //         if(material.getDefine("USE_TEXTURE") !== undefined) {
    //             material.define("USE_TEXTURE", true);
    //         }
    //         material.setProperty("texture", texture);
    //     }
    //     this['__proto__']._updateBlendFunc.call(this);
    //     this.setVertsDirty();        
    // }

    // public _validateRender() {
        
    // }

    // public _resetAssembler() {
    //     let assembler = this._assembler = new TextureAssembler();
    //     assembler.init(this);
    //     this._updateColor();
    //     this.setVertsDirty();
    // }

    // _hitTest (cameraPt: Vec2) {
    //     let node = this.node;
    //     let size = node.getComponent(UITransform),
    //         w = size.width,
    //         h = size.height,
    //         testPt = _vec2_temp;
        
    //     node['_updateWorldMatrix']();
    //     // If scale is 0, it can't be hit.
    //     if (!Mat4.invert(_mat4_temp, node['_worldMatrix'])) {
    //         return false;
    //     }
    //     Vec2.transformMat4(testPt, cameraPt, _mat4_temp);
    //     return CommonUtils.isInPolygon(testPt, this.polygon);
    // }
}